unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShellAPI;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    Label1: TLabel;
    ListBox2: TListBox;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Label2: TLabel;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure checkToEnabled;
    procedure savePos;
  end;

var
  Form1: TForm1;
  chid: HWND;

implementation

{$R *.dfm}

function SplitOnWords(s:string; Delimiter: String):TStrings;
begin
  Result:=TStringList.create;
  Result.text:=stringReplace(s,Delimiter,#13#10,[rfReplaceAll]);
end;

Procedure GetSubChild(MainH:HWND; HList:TStringList;Splitter:string='');
Var ChildH:HWND;
    ClNameCH:array[0..255] of Char;
      NameCH:array[0..255] of Char;
    status: String;
begin
 if MainH=0 then Exit;
 ChildH:=FindWindowEx(MainH,0,nil,nil);
 while (ChildH <> 0) do		     //     ?
    begin
     GetClassName(ChildH,ClNameCH,255);
     GetWindowText(ChildH,NameCH,255);
    //       (  )
     if IsWindowVisible(ChildH) then status:='visible ' else status:=' [ HIDDEN ] ';
     HList.Add(Splitter+' |'+ IntToStr(ChildH)+':'+status+ClNameCH+'|'+NameCH);
     Application.ProcessMessages;
     GetSubChild(ChildH,HList,Splitter+Splitter);
     ChildH:=FindWindowEx(MainH,ChildH,nil,nil);
    end;
end;

procedure TForm1.checkToEnabled;
begin
  if ListBox2.ItemIndex<0 then begin
    Button2.Enabled:=False;
    Button3.Enabled:=False;
    Button4.Enabled:=False;
    Button5.Enabled:=False;
    Button6.Enabled:=False;
  end else begin
    Button2.Enabled:=True;
    Button3.Enabled:=True;
    Button4.Enabled:=True;
    Button5.Enabled:=True;
    Button6.Enabled:=True;
  end;
end;

procedure TForm1.savePos;
var last: Integer;
begin
  last:=ListBox2.ItemIndex;
  ListBox1Click(nil);
  if(ListBox2.Count>=last) then ListBox2.ItemIndex:=last;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Wnd: hWnd;
  buff: array[0..127] of Char;
begin
 Try
  ListBox1.Clear;
  ListBox2.Clear;
  Wnd := GetWindow(Handle, gw_HWndFirst);
  while Wnd <> 0 do begin { :}
    if (Wnd <> Application.Handle) and {- }
      IsWindowVisible(Wnd) and {- }
      (GetWindow(Wnd, gw_Owner) = 0) and {- }
      (GetWindowText(Wnd, buff, sizeof(buff)) <> 0) {-  }
      then begin
      GetWindowText(Wnd, buff, sizeof(buff));
      ListBox1.Items.Add(StrPas(buff));
    end;
    Wnd := GetWindow(Wnd, gw_hWndNext);
  end;
 except end;
  checkToEnabled;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ShowWindow(chid, SW_SHOW);
  savePos;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ShowWindow(chid, SW_HIDE);
  savePos;
end;

procedure TForm1.Button4Click(Sender: TObject);
var X,Y:Integer;
begin
  X:=StrToInt(InputBox(' ','  X ( ),  px:','0'));
  Y:=StrToInt(InputBox(' ','  Y ( ),  px:','0'));
  SetWindowPos(chid,HWND_TOP,X,Y,0,0,SWP_nosize);
  savePos;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  BringWindowToTop(chid);
  savePos;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
// SendMessage(chid, BM_CLICK, 0,0);
 SendMessage(chid, WM_LBUTTONDOWN, MK_LBUTTON, MakeLParam(5,5));
 SendMessage(chid, WM_LBUTTONUP, MK_LBUTTON, MakeLParam(5,5));
  savePos;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  ShellExecute( Handle, 'open', 'http://habrahabr.ru/users/mixonin/', nil, nil, SW_NORMAL );
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Button1.Click;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var
  wd: hWnd;
  ttt: TStringList;
  i: Integer;
begin
  checkToEnabled;
  if(ListBox1.ItemIndex<0) then exit;
  wd := FindWindow(nil,PChar(ListBox1.Items.Strings[ListBox1.ItemIndex]));
  ttt:=TStringList.Create;
  GetSubChild(wd,ttt,'_ ');
  ListBox2.Clear;
  for i := 0 to ttt.Count-1 do begin
    ListBox2.Items.Add(ttt.Strings[i]);
  end;
end;

procedure TForm1.ListBox2Click(Sender: TObject);
var
  name: String;
begin
  checkToEnabled;
  if(ListBox2.ItemIndex<0) then exit;
  name:=ListBox2.Items.Strings[ListBox2.ItemIndex];
  chid:=StrToInt(SplitOnWords(SplitOnWords(name,'|').Strings[1],':').Strings[0]);
//  ShowMessage(IntToStr(id));
//  SendMessage(id, WM_SHOWWINDOW, SW_SHOW, nil);
//  SendMessage(id, WM_SHOWWINDOW, SW_SHOW, MakeLParam(5,5));
//  SendMessage(id,CM_VISIBLECHANGED,Ord(False),0);
end;

end.
